cortex-tools.js
=========

Complete Cortex wallet implementation and utilities in JavaScript (and TypeScript).

cortex-tools.js is basing on ethers.js, but was modified to work with cortex blockchain network.

**Features:**

- Keep your private keys in your client, **safe** and sound
- Import and export **JSON wallets** (Geth, Parity and crowdsale)
- Meta-classes create JavaScript objects from any contract ABI, including **ABIv2** and **Human-Readable ABI**
- Connect to Cortex nodes: Cortex Mainnet, Cerebro Testnet
- **Tiny** (~84kb compressed; 270kb uncompressed)
- **Complete** functionality for all your needs
- Fully **TypeScript** ready, with definition files and full TypeScript source
- **MIT License** (including ALL dependencies); completely open source to do with as you please


Installing
----------

To use in [node.js](https://nodejs.org/):

```
/Users/cortex/my-app> npm install --save cortex-tools
```


Documentation
-------------

Connect to Cortex Mainnet / Testnet(Cerebro)

```js
const cortex = require('cortex-tools');
// Cortex Mainnet
let mainnetProvider = cortex.getDefaultProvider('cortex');
// Cerebro Testnet
let testnetProvider = cortex.getDefaultProvider('cerebro');
```

For other details, you can browse the [ethers.js API Documentation](https://docs.ethers.io/ethers.js/html/) online.

Donations
---------

I do this because I love it, but if you want to buy me a coffee, I won't say no. **:o)**

Cortex / Ethereum: `0x252331b45a1e499fb4d28cf55d344562e88030cf`


License
-------

Completely MIT Licensed. Including ALL dependencies.
